

#include <mcvip_priv.h>
#include <drv_tvp5158.h>

//"TVP5158_NTSC_06", 2-Ch D1
//"TVP5158_NTSC_12", 4-Ch D1
//"TVP5158_NTSC_14", 4-Ch Half-D1
//"TVP5158_NTSC_15", 4-Ch CIF
//"TVP5158_NTSC_16", 4-Ch D1 (16-bit)
//"TVP5158_NTSC_18", 4-Ch Half-D1 (16-bit)
//"TVP5158_NTSC_23", 8-Ch Half-D1
//"TVP5158_NTSC_21", 8-Ch CIF
//"TVP5158_NTSC_24", 4-Ch Half-D1 + 1-Ch D1
//"TVP5158_NTSC_19", 4-Ch CIF + 1-Ch D1
//"TVP5158_NTSC_22", 8-Ch CIF + 1-Ch D1

//"TVP5158_NTSC_07", 2-Ch D1 cropped
//"TVP5158_NTSC_13", 4-Ch D1 cropped
//"TVP5158_NTSC_09", 4-Ch Half-D1 cropped
//"TVP5158_NTSC_26", 4-Ch CIF cropped
//"TVP5158_NTSC_17", 4-Ch D1 (16-bit) cropped
//"TVP5158_NTSC_10", 4-Ch Half-D1 (16-bit) cropped
//"TVP5158_NTSC_25", 8-Ch Half-D1 cropped
//"TVP5158_NTSC_11", 8-Ch CIF cropped
//"TVP5158_NTSC_20", 4-Ch Half-D1 + 1-Ch D1 cropped
//"TVP5158_NTSC_27", 4-Ch CIF + 1-Ch D1 cropped
//"TVP5158_NTSC_28", 8-Ch CIF + 1-Ch D1 cropped

int MCVIP_tvp5158GetInfo(MCVIP_Hndl *hndl)
{
  strcpy(hndl->v4l2InputToUse, "TVP5158");

//  OSA_printf("VideoDecoderMode: %d\n", hndl->createPrm.videoDecoderMode);
  
  switch(hndl->createPrm.videoDecoderMode) {
    case MCVIP_VIDEO_DECODER_MODE_2CH_D1_PORT_A:
    case MCVIP_VIDEO_DECODER_MODE_2CH_D1_PORT_B:
      hndl->v4l2StdToUse = TVP5158_STD_NTSC_06;
  
      hndl->v4l2FrameInfo.width = 728;
      hndl->v4l2FrameInfo.height = 1050;
      break;

    case MCVIP_VIDEO_DECODER_MODE_2CH_D1_PORT_A_CROP:
    case MCVIP_VIDEO_DECODER_MODE_2CH_D1_PORT_B_CROP:
      hndl->v4l2StdToUse = TVP5158_STD_NTSC_07;
  
      hndl->v4l2FrameInfo.width = 712;
      hndl->v4l2FrameInfo.height = 1050;
      break;

    case MCVIP_VIDEO_DECODER_MODE_4CH_D1: //jen
      hndl->v4l2StdToUse = TVP5158_STD_NTSC_12;

      hndl->v4l2FrameInfo.height = 2100;
      hndl->v4l2FrameInfo.width = 728;
      break;

    case MCVIP_VIDEO_DECODER_MODE_4CH_D1_CROP: //jen
      hndl->v4l2StdToUse = TVP5158_STD_NTSC_13;

      hndl->v4l2FrameInfo.height = 2100;
      hndl->v4l2FrameInfo.width = 712;
      break;
    
    case MCVIP_VIDEO_DECODER_MODE_4CH_HALF_D1_PROG:
    case MCVIP_VIDEO_DECODER_MODE_4CH_HALF_D1: //jen
      hndl->v4l2StdToUse = TVP5158_STD_NTSC_14;
  
      hndl->v4l2FrameInfo.width = 368;
      hndl->v4l2FrameInfo.height = 2100;
      break;
    
    case MCVIP_VIDEO_DECODER_MODE_4CH_HALF_D1_PROG_CROP:
    case MCVIP_VIDEO_DECODER_MODE_4CH_HALF_D1_CROP: //jen
      hndl->v4l2StdToUse = TVP5158_STD_NTSC_09;
  
      hndl->v4l2FrameInfo.width = 360; //jen
      hndl->v4l2FrameInfo.height = 2100;
      break;
    
    case MCVIP_VIDEO_DECODER_MODE_4CH_CIF:
      hndl->v4l2StdToUse = TVP5158_STD_NTSC_15;
  
      hndl->v4l2FrameInfo.width = 368;
      hndl->v4l2FrameInfo.height = 1052;
      break;

    case MCVIP_VIDEO_DECODER_MODE_4CH_CIF_CROP:
      hndl->v4l2StdToUse = TVP5158_STD_NTSC_26;
  
      hndl->v4l2FrameInfo.width = 360; //jen
      hndl->v4l2FrameInfo.height = 1052;
      break;

    case MCVIP_VIDEO_DECODER_MODE_4CH_D1_16: //jen
      hndl->v4l2StdToUse = TVP5158_STD_NTSC_16;

      hndl->v4l2FrameInfo.height = 2100;
      hndl->v4l2FrameInfo.width = 728;
      break;
    
    case MCVIP_VIDEO_DECODER_MODE_4CH_D1_16_CROP: //jen
      hndl->v4l2StdToUse = TVP5158_STD_NTSC_17;

      hndl->v4l2FrameInfo.height = 2100;
      hndl->v4l2FrameInfo.width = 712;
      break;

    case MCVIP_VIDEO_DECODER_MODE_4CH_HALF_D1_16_PROG:
    case MCVIP_VIDEO_DECODER_MODE_4CH_HALF_D1_16: //jen
      hndl->v4l2StdToUse = TVP5158_STD_NTSC_18;
  
      hndl->v4l2FrameInfo.width = 368;
      hndl->v4l2FrameInfo.height = 2100;
      break;

    case MCVIP_VIDEO_DECODER_MODE_4CH_HALF_D1_16_PROG_CROP: 
    case MCVIP_VIDEO_DECODER_MODE_4CH_HALF_D1_16_CROP: //jen
      hndl->v4l2StdToUse = TVP5158_STD_NTSC_10;
  
      hndl->v4l2FrameInfo.width = 360; //jen
      hndl->v4l2FrameInfo.height = 2100;
      break;

    case MCVIP_VIDEO_DECODER_MODE_8CH_HALF_D1_PROG:
    case MCVIP_VIDEO_DECODER_MODE_8CH_HALF_D1:
      hndl->v4l2StdToUse = TVP5158_STD_NTSC_23;
  
      hndl->v4l2FrameInfo.width = 368;
      hndl->v4l2FrameInfo.height = 4093;
      break;

    case MCVIP_VIDEO_DECODER_MODE_8CH_HALF_D1_PROG_CROP:
    case MCVIP_VIDEO_DECODER_MODE_8CH_HALF_D1_CROP:
      hndl->v4l2StdToUse = TVP5158_STD_NTSC_25;
  
      hndl->v4l2FrameInfo.width = 360;
      hndl->v4l2FrameInfo.height = 4093;
      break;

    case MCVIP_VIDEO_DECODER_MODE_8CH_CIF:
      hndl->v4l2StdToUse = TVP5158_STD_NTSC_21;
  
      hndl->v4l2FrameInfo.width = 368;
      hndl->v4l2FrameInfo.height = 2104;
      break;
      
    case MCVIP_VIDEO_DECODER_MODE_8CH_CIF_CROP:
      hndl->v4l2StdToUse = TVP5158_STD_NTSC_11;
  
      hndl->v4l2FrameInfo.width = 360; //jen
      hndl->v4l2FrameInfo.height = 2104;
      break;
      
    case MCVIP_VIDEO_DECODER_MODE_4CH_HALF_D1_PLUS_D1:
//      hndl->v4l2StdToUse = TVP5158_STD_NTSC_23;
      hndl->v4l2StdToUse = TVP5158_STD_NTSC_24; //MAT
  
      hndl->v4l2FrameInfo.width = 368;
      hndl->v4l2FrameInfo.height = 3150;
      break;
      
    case MCVIP_VIDEO_DECODER_MODE_4CH_HALF_D1_PLUS_D1_CROP:
      hndl->v4l2StdToUse = TVP5158_STD_NTSC_20;
  
      hndl->v4l2FrameInfo.width = 360; //jen
      hndl->v4l2FrameInfo.height = 3150;
      break;
      
    case MCVIP_VIDEO_DECODER_MODE_4CH_CIF_PLUS_D1:
      hndl->v4l2StdToUse = TVP5158_STD_NTSC_19;
  
      hndl->v4l2FrameInfo.width = 368;
      hndl->v4l2FrameInfo.height = 2102;
      break;
      
    case MCVIP_VIDEO_DECODER_MODE_4CH_CIF_PLUS_D1_CROP:
      hndl->v4l2StdToUse = TVP5158_STD_NTSC_27;
  
      hndl->v4l2FrameInfo.width = 360; //jen
      hndl->v4l2FrameInfo.height = 2102;
      break;
      
    case MCVIP_VIDEO_DECODER_MODE_8CH_CIF_PLUS_D1:
      hndl->v4l2StdToUse = TVP5158_STD_NTSC_22;
  
      hndl->v4l2FrameInfo.width = 368;
      hndl->v4l2FrameInfo.height = 3154;
      break;

    case MCVIP_VIDEO_DECODER_MODE_8CH_CIF_PLUS_D1_CROP:
      hndl->v4l2StdToUse = TVP5158_STD_NTSC_28;
  
      hndl->v4l2FrameInfo.width = 360; //jen
      hndl->v4l2FrameInfo.height = 3154;
      break;

    default:
      OSA_printf("Invalid mode: %d\n", hndl->createPrm.videoDecoderMode);
      return OSA_EFAIL;  
  }  
  
  hndl->v4l2FrameInfo.offsetH = OSA_align(hndl->v4l2FrameInfo.width, 32);  
  hndl->v4l2FrameInfo.offsetV = hndl->v4l2FrameInfo.height;  
  
  return OSA_SOK;
}

int MCVIP_tvp5158Start(MCVIP_Hndl *hndl)
{
  int status=OSA_SOK;

  if(hndl->pI2cHndl[0]!=NULL) {

    // if cascade mode, init the second TVP5158
    switch(hndl->createPrm.videoDecoderMode) {

      case MCVIP_VIDEO_DECODER_MODE_8CH_HALF_D1_PROG:
      case MCVIP_VIDEO_DECODER_MODE_8CH_HALF_D1_PROG_CROP:
      case MCVIP_VIDEO_DECODER_MODE_8CH_HALF_D1:
      case MCVIP_VIDEO_DECODER_MODE_8CH_HALF_D1_CROP:
      case MCVIP_VIDEO_DECODER_MODE_8CH_CIF:
      case MCVIP_VIDEO_DECODER_MODE_8CH_CIF_CROP: //jen
      case MCVIP_VIDEO_DECODER_MODE_8CH_CIF_PLUS_D1:
      case MCVIP_VIDEO_DECODER_MODE_8CH_CIF_PLUS_D1_CROP: //jen

        if(hndl->pI2cHndl[1]==NULL)
          return OSA_EFAIL;

        OSA_printf(" MCVIP: TVP5158 init in progress for stage 1\n");
                
        status = TVP5158_setOfmMode(
                hndl->pI2cHndl[1], 
                hndl->createPrm.videoDecoderMode, 
                hndl->createPrm.videoIfMode, 
                hndl->createPrm.videoSystem, 
                1
              );
              
        if(status!=OSA_SOK) {
          return status;   
        }
        status = TVP5158_setAudioMode(hndl->pI2cHndl[1], 1);     
        if(status!=OSA_SOK) {
          return status;   
        }
        break;
    }      
    
    OSA_printf(" MCVIP: TVP5158 init in progress for stage 0\n");    
    
    status = TVP5158_setOfmMode(
                hndl->pI2cHndl[0], 
                hndl->createPrm.videoDecoderMode, 
                hndl->createPrm.videoIfMode, 
                hndl->createPrm.videoSystem, 
                0
              );
              
    if(status!=OSA_SOK)
      return status;
    status = TVP5158_setAudioMode(hndl->pI2cHndl[0], 0);     
        if(status!=OSA_SOK) {
          return status;   
        }
   if(gMCVIP_ctrl.max_tvp5158 >= 3) {
   	 status = TVP5158_setAudioMode(hndl->pI2cHndl[2], 2);     
        if(status!=OSA_SOK) {
          return status;   
        }        
     if(gMCVIP_ctrl.max_tvp5158 == 4) {
     	  status = TVP5158_setAudioMode(hndl->pI2cHndl[3], 3);     
        if(status!=OSA_SOK) {
          return status;
        }
     }
     	
   }     
    OSA_printf(" MCVIP: TVP5158 init done !!!\n");    
  }

  return status;
}


int MCVIP_tvp5158Setup(MCVIP_Hndl *hndl)
{

  return OSA_SOK;
}

int MCVIP_tvp5158Stop(MCVIP_Hndl *hndl)
{
  int status=OSA_SOK;

  if(hndl->pI2cHndl[0]!=NULL) {

    // if cascade mode, init the second TVP5158
    switch(hndl->createPrm.videoDecoderMode) {

      case MCVIP_VIDEO_DECODER_MODE_8CH_HALF_D1_PROG:
      case MCVIP_VIDEO_DECODER_MODE_8CH_HALF_D1_PROG_CROP:
      case MCVIP_VIDEO_DECODER_MODE_8CH_HALF_D1:
      case MCVIP_VIDEO_DECODER_MODE_8CH_HALF_D1_CROP:
      case MCVIP_VIDEO_DECODER_MODE_8CH_CIF:
      case MCVIP_VIDEO_DECODER_MODE_8CH_CIF_CROP: //jen
      case MCVIP_VIDEO_DECODER_MODE_8CH_CIF_PLUS_D1:
      case MCVIP_VIDEO_DECODER_MODE_8CH_CIF_PLUS_D1_CROP: //jen

        if(hndl->pI2cHndl[1]==NULL)
          return OSA_EFAIL;
                
        status = TVP5158_softReset(hndl->pI2cHndl[1]);
        if(status!=OSA_SOK)
          return status;   
             
        break;
    }      
    
    status = TVP5158_softReset(hndl->pI2cHndl[0]);
    if(status!=OSA_SOK)
      return status;
    
  }

  return status;
}


